/*****************************************************************************

		Copyright (c) My Company

 Project:  MYPROJ
 FileName: SWEEP.PRO
 Purpose: No description
 Written by: Visual Prolog
 Comments:
******************************************************************************/

include "myproj.inc"
include "myproj.con"
include "hlptopic.con"
/***************************************************
      sweep 
   ***************************************************/
   facts-apl
      nocopy point(WINDOW,PNT)
      mouse_isdown(WINDOW)

/**************************************	
     sweep
   **************************************/
   predicates
      connect(window,pntlist) 
      drawlines(window,pnt,pntlist) 
   clauses
      connect(_,[]):-!.
         connect(Win,[From | Rest]):-
         drawlines(Win,From,Rest), 
      connect(Win,Rest). 
      drawlines(_,_,[]):-!.
      drawlines(Win,pnt(X,Y),[pnt(ToX,ToY) |Rest]):-
         draw_Line(Win,pnt(X,Y),pnt(ToX,ToY)),
         drawlines(Win,pnt(X,Y),Rest).

   /*******************************************
     sweep
   *******************************************/
   predicates
      sweep_Draw(window Win,window AssertWin)
   clauses
      sweep_Draw(_Win,AssertWin):-
         win_Clear(_Win,color_White), 
         findall(X,point(AssertWin,X),List),
         connect(_Win,List).


%BEGIN_TLB Sweep toolbar, 13:50:41-5.3.2007, Code automatically updated!
/**************************************************************************
	Creation of toolbar: Sweep toolbar
**************************************************************************/

clauses

  tb_sweep_toolbar_Create(_Parent):-
ifdef use_tbar
	toolbar_create(tb_right,0x808080,_Parent,
		[tb_ctrl(id_clear,pushb,idb_mybmp_norm,idb_mybmp_down,idb_mybmp_down,"",1,1)]),
enddef
	true.
%END_TLB Sweep toolbar

%BEGIN_WIN Sweep
/**************************************************************************
        Creation and event handling for window: Sweep
**************************************************************************/

constants
%BEGIN Sweep, CreateParms, 13:58:58-5.3.2007, Code automatically updated!
  win_sweep_WinType = w_TopLevel
  win_sweep_Flags = [wsf_SizeBorder,wsf_TitleBar,wsf_Maximize,wsf_Minimize,wsf_Close,wsf_ClipSiblings,wsf_ClipChildren]
  win_sweep_RCT = rct(100,80,440,240)
  win_sweep_Menu = res_menu(idr_sweep_menu)
  win_sweep_Title = "Sweep"
  win_sweep_Help = idh_contents
%END Sweep, CreateParms

predicates

  win_sweep_eh : EHANDLER

clauses

  win_sweep_Create(_Parent):-
	win_Create(win_sweep_WinType,win_sweep_RCT,win_sweep_Title,
		   win_sweep_Menu,_Parent,win_sweep_Flags,win_sweep_eh,0).

%BEGIN Sweep, e_Create
  win_sweep_eh(_Win,e_Create(_),0):-!,
	cursor_Set( _Win, idc_sweep ),
%BEGIN Sweep, InitControls, 13:58:58-5.3.2007, Code automatically updated!
%END Sweep, InitControls
%BEGIN Sweep, ToolbarCreate, 13:58:58-5.3.2007, Code automatically updated!
	tb_sweep_toolbar_Create(_Win),
%END Sweep, ToolbarCreate
	!.
%END Sweep, e_Create
%MARK Sweep, new events

%BEGIN Sweep, e_Destroy
  win_sweep_eh(_Win,e_Destroy,0):-!,
      retractall(mouse_isdown(_Win)),
      retractall(point(_Win,_)),
	!.
%END Sweep, e_Destroy

%BEGIN Sweep, id_clear
  win_sweep_eh(_Win,e_Menu(id_clear,_ShiftCtlAlt),0):-!,
      retractall(mouse_isdown(_Win)),
      retractall(point(_Win,_)),
      win_Clear(_Win,color_White),
      !.
%END Sweep, id_clear

%BEGIN Sweep, e_Update
  win_sweep_eh(_Win,e_Update(_UpdateRct),0):-!,
  sweep_Draw(_Win,_Win),
 	!.
  win_sweep_eh(_Win,e_Menu(id_close,_ShiftCtlAlt),0):-!,
	win_Destroy(_Win).

  win_sweep_eh(_Win,e_Menu(id_maximize,_ShiftCtlAlt),0):-!,
	win_SetState(_Win, [wsf_Maximized]).

  win_sweep_eh(_Win,e_Menu(id_restore,_ShiftCtlAlt),0):-!,
	win_SetState(_Win, [wsf_Restored]).

win_sweep_eh(_Win,e_Menu(id_color,_ShiftCtlAlt),0):-!, 
      Pen=win_GetPen(_Win), 
      Pen=pen(Penwidth,PenStyle, Color),
      NewColor=dlg_ChooseColor(Color), 
      win_SetPen(_Win,pen(Penwidth,PenStyle,NewColor)),
      win_Invalidate(_Win).

%END Sweep, e_Update

%BEGIN Sweep, e_MouseUp
  win_sweep_eh(_Win,e_MouseUp(_PNT,_ShiftCtlAlt,_Button),0):-!,
      retractall(mouse_isdown(_Win)),
      win_Invalidate(_Win),
	!.
%END Sweep, e_MouseUp

%BEGIN Sweep, e_MouseMove
  win_sweep_eh(_Win,e_MouseMove(_PNT,_ShiftCtlAlt,_Button),0):-!,
  mouse_isdown(_Win),
      assert(point(_Win,_PNT)),
      draw_Pixel(_Win,_PNT,color_Black),
	!.
%END Sweep, e_MouseMove

%BEGIN Sweep, e_MouseDown

   win_sweep_eh(_Win,e_MouseDown(_PNT,_,mouse_button_right),0):-!,
      menu_PopUp(_Win,res_menu(idr_sweep_popup),_PNT, align_Right). 

  win_sweep_eh(_Win,e_MouseDown(_PNT,_ShiftCtlAlt,_Button),0):-!,
  retractall(mouse_isdown(_Win)), %1  4 
      retractall(point(_Win,_)), %2  
      assert(mouse_isdown(_Win)), %3 
      win_Invalidate(_Win), %4  
	!.
%END Sweep, e_MouseDown

%BEGIN Sweep, e_Size
  win_sweep_eh(_Win,e_Size(_Width,_Height),0):-!,
ifdef use_tbar
	toolbar_Resize(_Win),
enddef
	!.
%END Sweep, e_Size

%BEGIN Sweep, e_Menu, Parent window 
  win_sweep_eh(Win,e_Menu(ID,CAS),0):-!,
	PARENT = win_GetParent(Win),
	win_SendEvent(PARENT,e_Menu(ID,CAS)),
	!.
%END Sweep, e_Menu, Parent window

%END_WIN Sweep

